package dod;

import java.io.*;
import java.net.*;

import dod.game.GameLogic;

/**
 * Handles a Client from within the Server.
 */
public class ClientThread extends PlayerGuide implements Runnable {

	private BufferedReader input;
	private PrintWriter output;
	private int clientno;
	private Socket socket;
	private GameLogic Game;
	private ClientServerController CSC;

	/**
	 * Constructor for a new clientThread Allows the server to handle many
	 * Clients will STore the current game, The current client via No. , and the
	 * current Socket Creates the Streams
	 */
	public ClientThread(Socket Client, GameLogic game, int clientNo) {
		this.Game = game;
		this.clientno = clientNo;
		this.socket = Client;
		CSC = new ClientServerController();
		super.setCSC(CSC);
		super.setGame(game);
		// So we can see what unique clients have joined
		System.out.println(Client.toString());
		
		// creates streams
		try {

			input = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			output = new PrintWriter(new OutputStreamWriter(socket.getOutputStream()), false);

			// adds player to the game and tells them the goal required
			super.addGame(this);
		} catch (IOException e) {
			// this should never happen anyways
			System.err.println("Streams Not set Up for Client");
		}
	}

	@Override
	public void run() {
		String command = "";
		try{	
			
			// check to see if the client can do this
			super.checkTurn(this);
						
			// If there is a command
			while (command  != null){
				command = input.readLine();
				// If the command is null or STOP - Could have been either -  Kill the CLientThread
				if (command == null || command.equalsIgnoreCase("STOP")){
					System.out.println("Client " + clientno + " left");
					lostconnection(); //DEAL WITH LEAVING LATER
				}
				else{
					System.out.println("command sent was '" + command + "' by client No " + clientno );
					super.processCommand(command, this);
				}
			}
		}
		catch (IOException e){
			// Client has left - kill the Client Thread
			System.out.println("Client " + clientno + " left");
			lostconnection(); //DEAL WITH LEAVING LATER
			try {
				socket.close();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
	}
	
	/**
	 * Tell the game that the user has left to remove from map and start next persons turn
	 */
	private void lostconnection()
	{
		super.UserConnectionGone(this);
		try {
			socket.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Sends a message to the client
	 */
	protected void outputMessage(String message) {
		CSC.ServerToClientMessage(output, message);
	}

}
