package dod;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.text.ParseException;

import dod.game.GameLogic;

public class ServerLogic {
	
	static GameLogic game = null;
	static ServerSocket serverSocket;
	
	public ServerLogic(int portValue) throws IOException, ParseException {
		serverSocket = new ServerSocket(portValue);
		System.out.println("Started Server");
		game = new GameLogic("defaultMap"); // use one map which is the default, implement a file chooser
	}
	
	public void waitForPlayers() throws IOException{
		int ClientNo = 1;
		while (true)
			{	
				Socket Client = serverSocket.accept();
				System.out.println("Client Arrived");
				System.out.println("Start Thread for " + ClientNo);
				// create new client thread for multiple clients 
				ClientThread task = new ClientThread(Client, game, ClientNo); // CLIENT THREAD
				ClientNo++;
				new Thread(task).start();
			}
	}
	
	public void kill(){
		try {
			serverSocket.close();
		} catch (IOException e) {
			System.out.println("Could not Close ServerSocket");
		}
	}

}
