package dod;

import java.io.*;
import java.awt.*;
import java.awt.image.*;
import javax.imageio.*;

/**
 * Map used to create an image from the chars in the map supplied to it
 * @author Steven
 */
public class TileMap {
    // Initialise all variables 
    private int x;
    private int y;
    private int tileSize;
    private int mapWidth;
    private int mapHeight;
    private boolean colour = false;
    private BufferedImage img = null;
    
    
    /**
     * @param tileSize - size of the tile 40x40
     * @param heightv - height of map 5 or 7
     * @param widthv - width of map 5 or 7
     * sets all the needed variables to do a loop that can change
     */
    public TileMap(int tileSize, int heightv, int widthv){
        this.tileSize = tileSize;
        mapWidth = widthv; // get the map width
        mapHeight = heightv; // get the map height   
    }
    
    
    /**
     * @param g - graphic being created
     * @param multi - map sent to method from look reply
     * read the value in the map at a position and will translate that
     * into a graphic image that was pre-made
     */
    public void draw(Graphics2D g, char[][] multi) {
    	// for the whole map
        for (int row =0; row < mapHeight; row++){
            for (int col =0; col < mapWidth; col++){
                char rc = multi[row][col]; // get value
                colour = false;
                if (rc == '#'){ // wall{
                    try {
                        img = ImageIO.read(new File("WALL40.png")); // try and use this image
                    } catch (IOException e) { // could'nt find image
                    }
                }
                if (rc == '?' | rc == 'X'){ // Unknown or corners of wall
                    g.setColor(Color.BLACK);
                    colour = true;
                }
                if (rc == 'A'){ // Armour
                	 try {
                         img = ImageIO.read(new File("Shield40.png"));
                     } catch (IOException e) {
                     }
                }
                if (rc == 'L'){ // Lantern
                	try {
                        img = ImageIO.read(new File("Lantern40.png"));
                    } catch (IOException e) {
                    }
                }
                if (rc == 'H'){ // Health
                	try {
                        img = ImageIO.read(new File("HP40.png"));
                    } catch (IOException e) {
                    }
                }
                if (rc == 'S'){ // Sword
                	try {
                        img = ImageIO.read(new File("Sword40.png"));
                    } catch (IOException e) {
                    }
                }
                if (rc == '.'){ // Floor
                    try {
                        img = ImageIO.read(new File("WOOD40.png"));
                    } catch (IOException e) {
                    }
                }
                if (rc == 'G'){ // Gold
                    try {
                        img = ImageIO.read(new File("GOLD40.png"));
                    } catch (IOException e) {
                    }
                }
                if (rc == 'E'){ // Exit
                    try {
                        img = ImageIO.read(new File("EXIT40.png"));
                    } catch (IOException e) {
                    }
                }
                if (rc == 'P' | rc == 'B' | rc =='p'){ // Another Player
                    try {
                        img = ImageIO.read(new File("PLAYER40.png"));
                    } catch (IOException e) {
                    }
                }
                if (colour == true){ // If it was a unknown or corner tile
                	g.fillRect(x + col * tileSize, y + row * tileSize, tileSize, tileSize); // Fill a 40x40 square with colour
                }
                else{
                	g.drawImage(img, x + col * tileSize, y + row * tileSize, null); // add image at X,Y worked out by tile size
                }
            }
        }
    }
}