package dod.game.items;

/**
 * An item to represent gold
 * 
 */
public final class Gold extends GameItem {
	
	private int amount;	
	
	public Gold(int value){
		amount = value;
	}
	
	@Override
	public int getAmount(){
		return amount;
	}
	
	@Override
    public void processPickUp(GameItemConsumer player) {
	// Give the player gold
		player.addGold(amount);
    }

    @Override
    public boolean isRetainable() {
	// Gold increments the player gold count instantly, so isn't
	// "retainable" like
	// other objects
	return false;
    }

    @Override
    public String toString() {
	return "gold";
    }

    @Override
    public char toChar() {
	return 'G';
    }
}
